import * as mc from "@minecraft/server";
import * as mcui from "@minecraft/server-ui";
function isB(block, player) {
    let b = "items"
    try {
   player.runCommand(`fill ~~~ ~~~ ${block} [] replace barrier`);
      b = "blocks"
    }catch (error) {}
   return b;
}
const bolsnasLista = {
	"blayy:basic_bag": {
types: 6,
maxItems: 256
},	"blayy:iron_bag": {
types: 6,
maxItems: 512
},	"blayy:gold_bag": {
types: 6,
maxItems: 768
},	"blayy:diamond_bag": {
types: 6,
maxItems: 1024
},	"blayy:netherite_bag": {
types: 6,
maxItems: 1536
},
"blayy:basic_big_bag": {
	types: 12,
	maxItems: 256
	},	"blayy:iron_big_bag": {
	types: 12,
	maxItems: 512
	},	"blayy:gold_big_bag": {
	types: 12,
	maxItems: 768
	},	"blayy:diamond_big_bag": {
	types: 12,
	maxItems: 1024
	},	"blayy:netherite_big_bag": {
	types: 12,
	maxItems: 1536
	} 
}

function upCase(string) {
	let result = ""
	
	for (const arg of string.split("_")) {
		result += `${arg[0].toUpperCase()}${arg.slice(1, arg.length)} `
	}
	return result.slice(0, result.length - 1)
}

function getLoreItems(player, loreAll) {
	return new Promise((resolve) => {
		const itemGetName = []
		const itemGetAmount = []
		const form = new mcui.ActionFormData()
		.title("Export");
		
		for (const lore of loreAll) {
			form.button(`§l§n${upCase(String(lore).split("/")[0].replace(`${lore.split(":")[0]}:`, ""))} §5x${lore.split("/")[1]}`);
			itemGetAmount.push(Number(String(lore).split("/")[1]))
			itemGetName.push(String(lore).split("/")[0])
		}
		if (itemGetName.length === 0) form.button("No items :D")

		form
		.show(player)
		.then((result) => {
			if (result.canceled) return;
			const modalForm = new mcui.ModalFormData()
			.title("Quantity");
			modalForm.slider("Enter the quantity", 1, itemGetAmount[result.selection], 1);
			modalForm.show(player).then((r) => {
				if (r.canceled) getLoreItems(player);
				return resolve({
					itemSelect: itemGetName[result.selection], removeItems: r.formValues[0]
				});
			});
		});
	});
}

function getItemsForm(player, bolsa, item1) {
	return new Promise((resolve, reject) => {
		const inv = player.getComponent("inventory").container;
		const itemGetName = []
		const itemGetAmount = []

		const form = new mcui.ActionFormData()
		form.title("Import");
		
		let mfodase = 0
		item1.getLore().forEach(vatomanocu => {
			console.warn(vatomanocu.split("/")[1])
			let idiota = Number(vatomanocu.split("/")[1]);
			mfodase += idiota
		})
		let fds = item1.getLore().length
		

		for (let t = 0; t < inv.size; t++) {
			const item = inv.getItem(t);
			
			if (!item) continue;
			if (bolsnasLista[item.typeId]) continue;
		form.body(`${mfodase}/${bolsa.maxItems * bolsa.types} (${(bolsa.maxItems * bolsa.types) / 64} packs)    ;    ${fds}/${bolsa.types}`)
		    form.button(`§l§n${upCase(item.typeId.replace(`${item.typeId.split(":")[0]}:`, ""))} §5x${item.amount}`);		
			itemGetAmount.push(item.amount)
			itemGetName.push(item.typeId)
		}
		if (itemGetName.length === 0) form.button("No items :D")

		form
		.show(player)
		.then((result) => {
			if (result.canceled) return;
			const modalForm = new mcui.ModalFormData()
			.title("Quantity");
			modalForm.slider("Quantity", 1, itemGetAmount[result.selection], 1);
			modalForm.show(player).then((r) => {
				console.warn(mfodase+r.formValues[0])
				if (bolsa.maxItems * bolsa.types > mfodase + r.formValues[0] || bolsa.types > item1.getLore().length) {
					if (r.canceled) getItemsForm(player);
					return resolve({
						itemSelect: itemGetName[result.selection], removeItems: r.formValues[0]
					});

				}else{
					player.runCommandAsync("tellraw @s {\"rawtext\":[{\"translate\":\"§c§lBag is Full!!\"}]}")
				}
			
			});
		});
	});
}

mc.world.afterEvents.itemUse.subscribe(
	async ({
		itemStack: item, source: player
	}) => {
		const bolsa = bolsnasLista[item.typeId]
		if (bolsa) {
			var loreItemSet = item.getLore();
			const form = new mcui.ActionFormData()
			.title("Bag Inventory")
			.button("Import")
			.button("Export");
			form
			.show(player)
			.then((result) => {
				if (result.canceled) return;
				if (result.selection == 0) {
					getItemsForm(player, bolsa, item).then(({
						itemSelect, removeItems
					}) => {
						const lore = String(loreItemSet.filter(v => v?.split("/")[0] === itemSelect))
					console.warn(lore)
					 if (bolsa.maxItems < (removeItems + Number(lore.split("/")[1]))) return 
						if (lore && loreItemSet.indexOf(lore) > -1) {
							loreItemSet[loreItemSet.indexOf(lore)] = `${itemSelect}/${Number(lore.split("/")[1]) + removeItems}`
							item.setLore(loreItemSet);
							player.runCommandAsync(`clear @s ${itemSelect} 0 ${removeItems}`);
							player.getComponent("equippable").setEquipment("Mainhand", item);
						} else {
							loreItemSet.push(`${itemSelect}/${removeItems}`);
							player.runCommandAsync(`clear @s ${itemSelect} 0 ${removeItems}`);
							item.setLore(loreItemSet);
							player.getComponent("equippable").setEquipment("Mainhand", item);
						}
					});
				} else {
					getLoreItems(player, loreItemSet)
					.then(({
						itemSelect, removeItems
					}) => {
						const lore = String(loreItemSet.filter(v => v?.split("/")[0] === itemSelect))
						if (lore && loreItemSet.indexOf(lore) > -1) {
							if (Number(lore.split("/")[1]) > removeItems) {
								loreItemSet[loreItemSet.indexOf(lore)] = `${itemSelect}/${Number(lore.split("/")[1]) - removeItems}`
								item.setLore(loreItemSet);
								player.runCommandAsync(`give @s ${itemSelect} ${removeItems}`);
								player.getComponent("equippable").setEquipment("Mainhand", item);
							} else {
								item.setLore(loreItemSet.filter(v => v.split("/")[0] != itemSelect))
								player.runCommandAsync(`give @s ${itemSelect} ${removeItems}`);
								player.getComponent("equippable").setEquipment("Mainhand", item);
								return;
							}
						}
					});
				}
			});
		}
	},
);